xquery version "1.0-ml";

import module namespace rest="http://marklogic.com/appservices/rest"
    at "/MarkLogic/appservices/utils/rest.xqy";
       
import module namespace endpoints = "http://wheelfactory.com/rest/endpoints" at "endpoints.xqy";

import module namespace wheel = "http://wheelfactory.com" at "wheel.xqy";

declare option xdmp:mapping "false";

try {
  let $params := rest:process-request(endpoints:request('/wheel-proxy.xqy'))
  return
    let $action := map:get($params, "action") return
        if($action eq "get-wheel")then
            wheel:retrieve-wheel(map:get($params, "id"))
        else if($action eq "put-wheel")then
            wheel:store-wheel(map:get($params, "id"), xdmp:get-request-body())
        else if($action eq "get-wheel-list")then
            wheel:inventory()
        else if($action eq "post-wheel")then
            wheel:create-wheel(xdmp:get-request-body())
        else
            <unknown/>
} catch ($e) {
  rest:report-error($e)
}
